package HTret;
import java.util.*;

public class ControlThread implements Runnable {
  private static Vector queue;
  private static int numberOfQueueEntries;
  private static Hashtable managementTable;
  static String realm;
  static gui g;

  int threadMax;
  Thread[] session;

  public ControlThread(String input, String realm, int threadMax, gui g) {	
    this.g = g;
    numberOfQueueEntries = 0;
    queue = new Vector();
    managementTable = new Hashtable();
    pushQueue(input);
    this.realm = realm;
    this.threadMax = threadMax;
    session = new Thread[threadMax];
  }
  public void run() {
    ThreadGroup engines = new ThreadGroup("Engine Thread");
    for(;;)  {
      if  (g.stopRequest)  {
        if (engines.activeCount() == 0) {
          g.log("Stopped.");
          return;
        }
      } else {
        int nullCount = 0;
        for(int i = 0; i < threadMax; i++)  {
          if  ((session[i] == null) || !(session[i].isAlive()))  {
            String url = popQueue();
            if  (url == null) {
              nullCount++;
              continue;
            }
            synchronized(managementTable) {
              managementTable.put(url, "");
            }
            session[i] = new Thread(engines, new Engine(i, url));
            session[i].start();
          }
        }
        if (nullCount == threadMax)  {
          g.log("End of job.");
          return;
        }
      }
      try {
        Thread.sleep(200);
      } catch(InterruptedException e) {}
    }
  }

  public static void pushQueue(String str) {
    synchronized(queue) {
      synchronized(managementTable) {
        if  (!managementTable.containsKey(str))  {
          queue.addElement(str);
          numberOfQueueEntries++;
        }
        g.queueEntries.setText(Integer.toString(numberOfQueueEntries));
        return;
      }
    }
  }

  public static String popQueue() {
    synchronized(queue)  {
      synchronized(managementTable) {
        String s;
        do  {
          try  {
            s = (String)queue.firstElement();
            queue.removeElementAt(0);
          } catch (NoSuchElementException e)  {
            return null;
          }
          numberOfQueueEntries--;
        } while(managementTable.containsKey(s));
        g.queueEntries.setText(Integer.toString(numberOfQueueEntries));
        return s;
      }
    }
  }

}
