package HTret;
import java.awt.*;
import java.io.*;

public class gui extends Frame {
  static String version = "1.00";
  static String copyright = "\n    Copyright (c) 1997, NIFTY-Serve FAI/M.Murakami(SDI00556@niftyserve.or.jp)";
  static int THREADMAX = 8;

  TextField inputURL;
  TextField realmURL;
  TextField localPath;
  Label[] monitorField = new Label[THREADMAX];
  Label queueEntries;           // This field is peeked by Control Thread.
  TextArea logField;

  Thread controlThread;
  boolean stopRequest = false;  // This field is peeked by Control Thread.

  public gui()  {
    setTitle("HyperText retriever G - " + version);

    resize(540, 340);
    setResizable(false);

    setLayout(new BorderLayout());

    Panel headerPanel = new Panel();
    headerPanel.setLayout(new GridLayout(0,1));
    headerPanel.add(new Label("root   URL:"));
    headerPanel.add(new Label("realm  URL:"));
    headerPanel.add(new Label("local path:"));
    for(int i = 1; i <= THREADMAX; i++)  {
      headerPanel.add(new Label("Thread No."+i+":"));
    }
    add("West", headerPanel);

    Panel centerPanel = new Panel();
    centerPanel.setLayout(new GridLayout(0,1));
    centerPanel.add(inputURL = new TextField(64));
    centerPanel.add(realmURL = new TextField(64));
    centerPanel.add(localPath = new TextField(64));
    for(int i = 0; i < THREADMAX; i++)  {
      monitorField[i] = new Label("    -----");
      centerPanel.add(monitorField[i]);
    }
    add("Center", centerPanel);

    Panel buttonPanel = new Panel();
    buttonPanel.setLayout(new GridLayout(0,1));
    buttonPanel.add(queueEntries = new Label("0"));
    buttonPanel.add(new Label(""));
    buttonPanel.add(new Button("Start"));
    buttonPanel.add(new Button("Stop"));
    buttonPanel.add(new Button("Clear"));
    buttonPanel.add(new Button("Done"));
    add("East", buttonPanel);

    add("South", logField =
      new TextArea(getTitle() + copyright, 6,40));

    show();
    inputURL.requestFocus();
  }
  public static void main(String args[])  {
    gui topLevel = new gui();
  }
  public boolean handleEvent(Event evt) {
    if (evt.id == Event.WINDOW_DESTROY) done();
    return super.handleEvent(evt);
}
  public boolean action(Event evt, Object obj) {
    if  (evt.arg.equals("Start")) {
      if ((controlThread == null) || !controlThread.isAlive()) {
        stopRequest = false;
        if  (inputURL.getText().equals("")) {
          alertMessage("Please specify an input URL.");
        } else {
          log("Control Thread start.");
          controlThread = new Thread(new ControlThread(inputURL.getText(), realmURL.getText(), THREADMAX, this));
          controlThread.start();
        }
      } else {
        alertMessage("Already started, thank you.");
      }
    } else if (evt.arg.equals("Stop")) {
      if ((controlThread == null) || !controlThread.isAlive())  {
        alertMessage("Control Thread not in Active.");
      } else {
        log("Stop request queued...");
        stopRequest = true;
      }
    } else if  (evt.arg.equals("Clear")) {
      logField.setText(getTitle() + copyright);
    } else if  (evt.arg.equals("Done")) {
      done();
    } else if (evt.target == inputURL)  {
      if (realmURL.getText().equals(""))
        realmURL.setText(inputURL.getText());
      realmURL.requestFocus();
      int textLength = realmURL.getText().length();
      realmURL.select(textLength, textLength);
    } else if (evt.target == realmURL)  {
      localPath.requestFocus();
      localPath.selectAll();
    } else if (evt.target == localPath)  {
      inputURL.requestFocus();
      inputURL.selectAll();
    }
    return true;
  }
  public void log(String message) {
    logField.appendText("\n"+message);
  }
  public void monitor(int n, String url)  {
    monitorField[n].setText(url);
  }
  public void alertMessage(String message)  {
    new AlertDialog(this, message);
  }
  public String getLocalPath() {
    String s = localPath.getText();
    if (s.equals(""))  return "";

    StringBuffer temp = new StringBuffer(s.length());
    for(int i = 0; i < s.length(); ++i)  {
      char ch = s.charAt(i);
      if (ch == '\\')  {
        temp.append("/");
      } else {
        temp.append(ch);
      }
    }
    String w = temp.toString();
    if (w.endsWith("/")) return w;
    return w + '/';
  }
  public void done() {
    if ((controlThread == null) || !controlThread.isAlive())  {
      System.exit(0);
    } else {
      alertMessage("Control Thread is active, please stop it.");
    }
  }
}
